USING: help.markup help.syntax ui.commands ui.tools.common ;
IN: ui.tools.error-list

ARTICLE: "ui.tools.error-list" "UI error list tool"
"The error list tool displays messages generated by tools which process source files and definitions. To display the error list, press " { $command tool "common" show-error-list } " in any UI tool window."
$nl
"The " { $vocab-link "source-files.errors" } " vocabulary contains backend code used by this tool."
{ $heading "Message icons" }
{ $table
    { { $strong "Icon" } { $strong "Message type" } { $strong "Reference" } }
    ! { { $image "vocab:ui/tools/error-list/icons/note.png" } "Parser note" { $link "parser" } }
    ! { { $image "vocab:ui/tools/error-list/icons/syntax-error.png" } "Syntax error" { $link "syntax" } }
    { { $image "vocab:ui/tools/error-list/icons/compiler-error.png" } "Compiler error" { $link "compiler-errors" } }
    { { $image "vocab:ui/tools/error-list/icons/linkage-error.png" } "Linkage error" { $link "loading-libs" } }
    { { $image "vocab:ui/tools/error-list/icons/help-lint-error.png" } "Help lint failure" { $link "help.lint" } }
    { { $image "vocab:ui/tools/error-list/icons/unit-test-error.png" } "Unit test failure" { $link "tools.test" } }
    { { $image "vocab:ui/tools/error-list/icons/deprecation-note.png" } "Deprecated words used" { $link "tools.deprecation" } }
} ;

ABOUT: "ui.tools.error-list"
